#include <mex.h>
#ifdef WIN32
#include <windows.h>
#endif
#ifdef WIN64
#include <windows.h>
#endif
#include "AviSocket.h"
#include <math.h>

void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[]){

	int buflen, frame_no, dims[1];
	double * buffer, frame_time;

	AviSocket * aviSocket = (AviSocket *)mxGetPr(prhs[0]);
	int frame_number = (int)mxGetScalar(prhs[1]);

	/*
	if( frame_no > avi_helper -> nframes || frame_no < 1){
		printf("dxAviReadMex: input frame number should be in [1, #frames] \n", frame_no, avi_helper -> nframes);
		plhs[0] = mxCreateDoubleMatrix(0, 0, mxREAL);
		return;
	}
	*/

	aviSocket -> write_framenumber_to_socket(frame_number);
	unsigned char * pixmap;
	int readw, readh;
	aviSocket -> read_frame_from_socket(readw, readh, pixmap);
	
	buflen = readw*readh*3;
	plhs[0] = mxCreateDoubleMatrix(buflen, 1, mxREAL);
	buffer = mxGetPr(plhs[0]);
	for(int i = 0; i<buflen; i++ )
		buffer[i] = pixmap[i];
	
}

