#pragma warning(disable : 4995)
#pragma warning(disable : 4996)

#include <tchar.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
typedef TCHAR *PTCHAR;
#include <streams.h>
#include <qedit.h>
#include <vector>
#include <atlstr.h>
#include <iostream>

bool getFilterGraphAndStuff(void ** pGraph, void ** pMediaControl, void ** pMediaEvent, void ** pMediaSeeking, void ** pMediaFilter);
IPin *GetPin(IBaseFilter *pFilter, PIN_DIRECTION PinDir);
IPin *GetPin(IBaseFilter *pFilter, PIN_DIRECTION PinDir, int n);
bool addRenderer(WCHAR* renderername, IGraphBuilder *pGraph, IPin **outputPin);
bool addSource(WCHAR* sourcename, IGraphBuilder *pGraph, IPin **outputPin);
bool addVideoSampleGrabber(IGraphBuilder *pGraph, IPin **outputPin, ISampleGrabber ** sampleGrabber);
bool addFileWriter(WCHAR* filename, IGraphBuilder *pGraph, IPin **outputPin);
bool addFilter(REFCLSID filterCLSID, WCHAR* filtername, IGraphBuilder *pgraph,
               IPin **outputPin, int numberOfOutput=1);
bool addSourceOnlyFilter(REFCLSID filterCLSID, WCHAR* filtername, IGraphBuilder *pGraph,
               IPin **outputPin, int numberOfOutput);
bool removeAllFilters(IGraphBuilder *pGraph);
std::vector<CString> enumFilters(IGraphBuilder *pGraph);
void enumFilters(REFCLSID CLSIDcategory, std::vector<CString>& names, std::vector<CLSID>& clsidFilters);
bool addFilterByEnum(REFCLSID CLSIDcategory, CString filtername, IGraphBuilder *pGraph, IPin **outputPin, int numberOfOutput);
bool changeCompressorOptions(IPin **outputPin, int numberOfOutput, int& iKeyFrames, int& iPFrames, double& dQuality);
bool changeVideoCaptureOptions(IBaseFilter* pVideoSource, long lParam, long lValue, long lFlags);
bool changeVideoCaptureOptionsByName(WCHAR* wcVideoSource, IFilterGraph* pGraph, long lParam, long lValue, long lFlags);

#define ERR_BUFFER_LEN 1000
#define DISPLAY_ERROR_BOX(errStr, ___FILE, ___LINE) {\
	char errMessage[ERR_BUFFER_LEN];\
	sprintf_s(errMessage, ERR_BUFFER_LEN, "%s:%d %s \n", ___FILE, ___LINE, errStr);\
	fprintf(stderr, errMessage);\
}

//DISPLAY_ERROR_BOX(tmp, __FILE__, __LINE__)
//::MessageBox( NULL, errMessage, "Error", MB_OK | MB_ICONINFORMATION );